#!/bin/bash

# set charon.install_virtual_ip = no to prevent the daemon from also installing the VIP

set -o nounset
set -o errexit

defined_if=$1

#VTI_IF="vti${PLUTO_UNIQUEID}"
VTI_IF="vti${defined_if}"

case "${PLUTO_VERB}" in
    up-client)
        ip tunnel del "${VTI_IF}" 2>1 >/dev/null || true
        ip tunnel add "${VTI_IF}" local "${PLUTO_ME}" remote "${PLUTO_PEER}" mode vti \
            okey "${PLUTO_MARK_OUT%%/*}" ikey "${PLUTO_MARK_IN%%/*}" 

	#ip tunnel add "${VTI_IF}" local "${PLUTO_ME}" remote "${PLUTO_PEER}" mode vti
        ip link set "${VTI_IF}" up
        ip addr add "${PLUTO_MY_SOURCEIP}" dev "${VTI_IF}"
        if [ "0.0.0.0" != "${PLUTO_PEER_CLIENT}" ] && [ "0.0.0.0/0" != "${PLUTO_PEER_CLIENT}" ] ; then
            ip route add "${PLUTO_PEER_CLIENT}" dev "${VTI_IF}"
        fi
        #ip route add "${PLUTO_PEER_CLIENT}" dev "${VTI_IF}" 
        sysctl -w "net.ipv4.conf.${VTI_IF}.disable_policy=1" 2>1 >/dev/null
        /usr/bin/dbus-send --system --print-reply --dest=net.telco.NetIfMonitor /net/telco/NetIfMonitor net.telco.NetIfMonitor.add_addr string:"${VTI_IF}" string:"${PLUTO_MY_SOURCEIP}" 2>1 >/dev/null || true
        ;;
    down-client)
        ip tunnel del "${VTI_IF}"
        /usr/bin/dbus-send --system --print-reply --dest=net.telco.NetIfMonitor /net/telco/NetIfMonitor net.telco.NetIfMonitor.del_addr string:"${VTI_IF}" string:"${PLUTO_MY_SOURCEIP}" 2>1 >/dev/null || true
        ;;
    up-client-v6)
        ip -6 tunnel del "${VTI_IF}" 2>1 >/dev/null || true
        ip -6 tunnel add "${VTI_IF}" local "${PLUTO_ME}" remote "${PLUTO_PEER}" mode vti6 \
            okey "${PLUTO_MARK_OUT%%/*}" ikey "${PLUTO_MARK_IN%%/*}" 

        ip -6 link set "${VTI_IF}" up
        ip -6 addr add "${PLUTO_MY_SOURCEIP6_1}" dev "${VTI_IF}"
        if [ "::" != "${PLUTO_PEER_CLIENT}" ] && [ "::/0" != "${PLUTO_PEER_CLIENT}" ] ; then
            ip -6 route add "${PLUTO_PEER_CLIENT}" dev "${VTI_IF}"
        fi

        sysctl -w "net.ipv6.conf.${VTI_IF}.disable_policy=1" 2>1 >/dev/null
	/usr/bin/dbus-send --system --print-reply --dest=net.telco.NetIfMonitor /net/telco/NetIfMonitor net.telco.NetIfMonitor.add_addr string:"${VTI_IF}" string:"${PLUTO_MY_SOURCEIP6_1}" 2>1 >/dev/null || true
        ;;
    down-client-v6)
        ip -6 tunnel del "${VTI_IF}"
	/usr/bin/dbus-send --system --print-reply --dest=net.telco.NetIfMonitor /net/telco/NetIfMonitor net.telco.NetIfMonitor.del_addr string:"${VTI_IF}" string:"${PLUTO_MY_SOURCEIP6_1}" 2>1 >/dev/null || true
        ;;
esac

